const GM = chrome.i18n.getMessage

var $launcher = $(`<div id="tool4seller-launcher"><div id="tool4seller-launcher__inner"><span id="tool4seller-launcher-label">${GM("listingQualityScore")}</span><span id="tool4seller-launcher-total"></span></div></div>`);

var $container = $(`
<div id="tool4seller-container" style="display: none;">
    <div id="tool4seller-container-legend">
        <span class="tool4seller-container-logo">tool4seller</span>
        <div class="tool4seller-container-legend-aside">
            <a href=${GM("feedbackLink")} target="_blank" class="toll4seller-container-link">${GM("feedback")}</a>
            <a href="javascript:;" class="toll4seller-container-link" id="tool4seller-container-legend-close">${GM("hide")}</a>
        </div>
    </div>
    <div id="tool4seller-container-head" class="tool4seller-clearfix">
        <div id="tool4seller-container-pie">
            <div id="tool4seller-container-pie-inner">
                <div id="tool4seller-container-pie-graph">
                    <svg viewBox="0 0 100 100">
                        <path d="M 50 50 m 0 -47 a 47 47 0 1 1 0 94 a 47 47 0 1 1 0 -94" stroke="#e5e9f2" stroke-width="4.8" fill="none" class="el-progress-circle__track"></path>
                        <path id="tool4seller-container-pie-graph-process" d="M 50 50 m 0 -47 a 47 47 0 1 1 0 94 a 47 47 0 1 1 0 -94" stroke-linecap="round" stroke="#20a0ff" stroke-width="4.8" fill="none" style="stroke-dasharray: 299.08px, 299.08px; stroke-dashoffset: 299.08px; transition: stroke-dashoffset 0.6s ease 0s, stroke 0.6s ease 0s;"></path>
                    </svg>
                </div>
                <div class="tool4seller-container-pie-text">
                    <div id="tool4seller-container-pie-score"></div>
                    <div class="tool4seller-container-pie-label">${GM("listingQualityScore")}</div>
                </div>
            </div>
        </div>
        <div id="tool4seller-container-overview">
            <div class="tool4seller-container-overview-item tool4seller-container-overview-item__good"><span class="tool4seller-container-overview-item-num"></span>${GM("overview_1")}</div>
            <div class="tool4seller-container-overview-item tool4seller-container-overview-item__warn"><span class="tool4seller-container-overview-item-num"></span>${GM("overview_2")}</div>
            <div class="tool4seller-container-overview-item tool4seller-container-overview-item__bad"><span class="tool4seller-container-overview-item-num"></span>${GM("overview_3")}</div>
        </div>
    </div>
    <div id="tool4seller-container-list">
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__title">
            <div class="tool4seller-container-list-item-title">${GM("title")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkSiteTracker")} id="title_suggestion" target="_blank" class="toll4seller-container-link">${GM("intelligenSuggestions")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__image">
            <div class="tool4seller-container-list-item-title">${GM("image")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkSiteTracker")} id="image_suggestion" target="_blank" class="toll4seller-container-link">${GM("optimization")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__bullet">
            <div class="tool4seller-container-list-item-title">Bullet Point</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("suggestions")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__description">
            <div class="tool4seller-container-list-item-title">${GM("description")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("optimization")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__fba">
            <div class="tool4seller-container-list-item-title">${GM("fulfilledBy")}</div>
            <div class="tool4seller-container-list-item-desc">${GM("recommend_1")}</div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__star">
            <div class="tool4seller-container-list-item-title">${GM("score")}</div>
            <div class="tool4seller-container-list-item-desc">${GM("recommend_2")}</div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__review">
            <div class="tool4seller-container-list-item-title">${GM("numberOfReview")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("suggestions")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__video">
            <div class="tool4seller-container-list-item-title">${GM("video")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("optimization")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__faq">
            <div class="tool4seller-container-list-item-title">${GM("QandA")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("suggestions")}</a>
            </div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item" id="tool4seller-container-list-item__discount">
            <div class="tool4seller-container-list-item-title">${GM("promotions")}</div>
            <div class="tool4seller-container-list-item-desc">${GM("discounts_desc")}</div>
            <div class="tool4seller-container-list-item-score"></div>
        </div>
        <div class="tool4seller-container-list-item">
            <div class="tool4seller-container-list-item-title">Search Term</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} id="searchTerm_suggestion" target="_blank" class="toll4seller-container-link">${GM("evaluateNow")}</a>
            </div>
            <div class="tool4seller-container-list-item-score">${GM("unknown")}</div>
        </div>
        <div class="tool4seller-container-list-item">
            <div class="tool4seller-container-list-item-title">${GM("keywordRanking")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("evaluateNow")}</a>
            </div>
            <div class="tool4seller-container-list-item-score">${GM("unknown")}</div>
        </div>
        <div class="tool4seller-container-list-item">
            <div class="tool4seller-container-list-item-title">${GM("ASINIndex")}</div>
            <div class="tool4seller-container-list-item-desc">
                <a href=${GM("linkTrackerListing")} target="_blank" class="toll4seller-container-link">${GM("evaluateNow")}</a>
            </div>
            <div class="tool4seller-container-list-item-score">${GM("unknown")}</div>
        </div>
    </div>
</div>`
);

$(function () {
    (function (i, s, o, g, r, a, m) {
        i['GoogleAnalyticsObject'] = r;
        i[r] = i[r] || function () {
            (i[r].q = i[r].q || []).push(arguments)
        }, i[r].l = 1 * new Date();
        a = s.createElement(o),
            m = s.getElementsByTagName(o)[0];
        a.async = 1;
        a.src = g;
        m.parentNode.insertBefore(a, m)
    })(window, document, 'script', '//www.google-analytics.com/analytics.js', 'ga');
    ga('create', 'UA-53063033-14', 'auto');
    ga('send', 'pageview');


    $.ajax({
        url: window.DAS_EXTRACTOR_URL + '?r=' + Math.random(),
        type: 'get',
        success: function (str) {
            eval(str);
            DAS_init();
        }
    });

})

function DAS_init() {
    var breadOffset = $('#dp').offset();
    var allScoresMap = DAS_getAllScoresMap();
    var totalScore = 0;
    var goodCount = 0,
        warnCount = 0,
        badCount = 0;
    Object.keys(allScoresMap).forEach(e => {
        totalScore += allScoresMap[e]
        if (allScoresMap[e] >= 10) {
            goodCount++;
        } else if (allScoresMap[e] > 0) {
            warnCount++;
        } else {
            badCount++;
        }
    });

    $launcher.css({
        'top': breadOffset.top - 5 + 'px'
    });

    $('#title_feature_div').after($launcher);
    if (window.ga) {
        window.ga('send', 'event', 'Listing评分', '展示评分标签', '', 1);
    }
    $('body').append($container);


    $launcher.on('click', '#tool4seller-launcher__inner', function () {
        showContainer();
        setScoreProgress(totalScore);
        if (window.ga) {
            window.ga('send', 'event', 'Listing评分', '点击评分标签', '', 1);
        }

    });

    $('#title_suggestion').on('click', function () {
        if (window.ga) {
            window.ga('send', 'event', 'Listing评分', '点击前往查看详情', '点击改进建议', 1);
        }
    });
    $('#image_suggestion').on('click', function () {
        if (window.ga) {
            window.ga('send', 'event', 'Listing评分', '点击前往查看详情', '点击了解评分标准和优化方案', 1);
        }
    });
    $('#searchTerm_suggestion').on('click', function () {
        if (window.ga) {
            window.ga('send', 'event', 'Listing评分', '点击前往查看详情', '前往评估', 1);
        }
    });

    $('#tool4seller-container-legend-close').on('click', function () {
        hideContainer();
    });


    fill();


    setInterval(function () {
        fill();
    }, 2000);

    function fill() {
        allScoresMap = DAS_getAllScoresMap();

        var _totalScore = 0;
        var _goodCount = 0,
            _warnCount = 0,
            _badCount = 0;

        Object.keys(allScoresMap).forEach(e => {
            _totalScore += allScoresMap[e]
            if (allScoresMap[e] >= 10) {
                _goodCount++;
            } else if (allScoresMap[e] > 0) {
                _warnCount++;
            } else {
                _badCount++;
            }
        });

        totalScore = _totalScore;
        goodCount = _goodCount;
        warnCount = _warnCount;
        badCount = _badCount;

        $('#tool4seller-launcher-total').text(totalScore);
        $('#tool4seller-launcher__inner').toggleClass('is-low', totalScore <= 60);
        $('#tool4seller-container-pie-score').text(totalScore);
        $('#tool4seller-container-overview').find('.tool4seller-container-overview-item__good .tool4seller-container-overview-item-num').text(goodCount);
        $('#tool4seller-container-overview').find('.tool4seller-container-overview-item__warn .tool4seller-container-overview-item-num').text(warnCount);
        $('#tool4seller-container-overview').find('.tool4seller-container-overview-item__bad .tool4seller-container-overview-item-num').text(badCount);
        Object.keys(allScoresMap).forEach(e => {
            fillItemScore($('#tool4seller-container-list-item__' + e), allScoresMap[e]);
        });
    }

}

function setScoreProgress(score) {
    var $progress = $('#tool4seller-container-pie-graph-process');
    var strokeColor = '#e5e9f2';
    var strokeDashOffset = 299.08 * (1 - score / 100);

    if (score >= 80) {
        strokeColor = '#6be29e';
    } else if (score >= 50) {
        strokeColor = '#ffb400';
    } else {
        strokeColor = '#ff3e65';
    }

    $progress.attr('stroke', strokeColor);
    $progress.css({
        'stroke-dashoffset': strokeDashOffset + 'px'
    });
}

function fillItemScore($item, score) {
    let $score = $item.find('.tool4seller-container-list-item-score');
    $score.text(score);
    if (score >= 10) {
        $score.attr('data-grade', 'good');
    } else if (score > 0) {
        $score.attr('data-grade', 'warn');
    } else {
        $score.attr('data-grade', 'bad');
    }
}

function showContainer() {
    $container.css({
        'top': 100 + window.scrollY + 'px'
    }).show();
}

function hideContainer() {
    $container.hide();
}

function DAS_getAllScoresMap() {
    return {
        'title': DAS_getTitleScore(),
        'image': DAS_getImageScore(),
        'bullet': DAS_getBulletsScore(),
        'description': DAS_getDescriptionScore(),
        'fba': DAS_getFBAScore(),
        'star': DAS_getStarScore(),
        'review': DAS_getReviewScore(),
        'video': DAS_getVideoScore(),
        'faq': DAS_getAnswerScore(),
        'discount': DAS_getDiscountScore(),
    }
}

function DAS_getTitleScore() {
    var title = DAS_getTitle();
    if (title === void (0)) {
        return 0;
    } else {
        return (title.length >= 40 && title.length <= 80)? 10 : 0;
    }
}

function DAS_getImageScore() {
    var imagesCount = DAS_getImages().length;
    return imagesCount > 5 ? 10 : 2 * imagesCount;
}

function DAS_getBulletsScore() {
    var bulletsCount = DAS_getBullets().length;
    return bulletsCount > 5 ? 10 : 2 * bulletsCount;
}

function DAS_getDescriptionScore() {
    var decs = DAS_getDescription();
    var hasStyle = DAS_hasDescriptionStyle();
    var ret = 0;

    if (decs.length >= 250) {
        ret += 6;
    }
    if (hasStyle) {
        ret += 4;
    }

    return ret;
}

function DAS_getFBAScore() {
    return DAS_isFBA() ? 10 : 0;
}

function DAS_getStarScore() {
    var stars = DAS_getStars();
    return stars >= 4 ? 10 : 0;
}

function DAS_getReviewScore() {
    var reviewsCount = DAS_getReviewsCount();
    return reviewsCount >= 15 ? 10 : 0;
}

function DAS_getVideoScore() {
    var videoCount = DAS_getVideoCount();
    return videoCount >= 1 ? 10 : 0;
}

function DAS_getAnswerScore() {
    var answersCount = DAS_getAnswersCount();
    return answersCount >= 2 ? 10 : 5 * answersCount;
}

function DAS_getDiscountScore() {
    return DAS_hasDiscount() ? 10 : 0;
}
